package com.analogbit.puzzletools.client.slidingblocks.gui;

import com.analogbit.puzzletools.client.util.TitledDialogBox;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * For popping up errors at the user.
 */
public class ErrorDialogBox extends TitledDialogBox {

	private VerticalPanel vp;
	private Button closeButton;
	
	public ErrorDialogBox() {
		this("Error");
	}

	public ErrorDialogBox(String message) {
		super("Error");
		vp = new VerticalPanel();
		closeButton = new Button("Ok");
		vp.add(new Label(message));
		vp.add(closeButton);
		vp.setCellHorizontalAlignment(closeButton, HasHorizontalAlignment.ALIGN_CENTER);
		setWidget(vp);
		
		closeButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				hide();
			}
		});
	}
}
