package com.analogbit.puzzletools.client.slidingblocks.gui;

import com.analogbit.puzzletools.client.util.TitledDialogBox;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * Popup to display while solving the puzzle, shows some stats. 
 */
public class StatusDialogBox extends TitledDialogBox {
	
	public static final String TITLE = "Solving Puzzle...";
	private Label depthLabel = new Label("Current depth: 0");
	private Label positionLabel = new Label("Positions evaluated: 0");
	private Label dupLabel = new Label("Duplicate positions: 0");
	private Label pendingLabel = new Label("Positions pending: 1");
	private Image animatedIcon = new Image("working.gif");
	private Button cancelButton = new Button("Cancel");
	private VerticalPanel vpanel = new VerticalPanel();
	
	public StatusDialogBox() {
		super(TITLE);
		setAnimationEnabled(true);
		
		vpanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		vpanel.add(animatedIcon);
		vpanel.add(depthLabel);
		vpanel.add(pendingLabel);
		vpanel.add(positionLabel);
		vpanel.add(dupLabel);
		vpanel.add(cancelButton);
		
		setWidget(vpanel);
	}

	public HandlerRegistration addCancelClickHandler(ClickHandler handler) {
		return cancelButton.addClickHandler(handler);
	}
	
	public void setDepth(int depth) {
		depthLabel.setText("Current depth: " + depth);
	}

	public void setPositionsEvaluated(long positionsEvaluated) {
		positionLabel.setText("Positions evaluated: " + positionsEvaluated);
	}
	
	public void setDuplicatePositions(long duplicatePositions) {
		dupLabel.setText("Duplicate positions: " + duplicatePositions);
	}

	public void setPending(int positionsPending) {
		pendingLabel.setText("Positions pending: " + positionsPending);
		
	}
	
}
