package com.analogbit.puzzletools.client.slidingblocks.state;

public class BlockInPositionGoalState implements GoalState {
	private int blockIndex;
	private int blockPosX;
	private int blockPosY;
	
	public BlockInPositionGoalState(int blockIndex, int blockPosX, int blockPosY) {
		this.blockIndex = blockIndex;
		this.blockPosX = blockPosX;
		this.blockPosY = blockPosY;
	}
	
	public BlockInPositionGoalState(Grid grid, Block block, int blockPosX, int blockPosY) {
		this.blockPosX = blockPosX;
		this.blockPosY = blockPosY;
		this.blockIndex = grid.getBlocks().indexOf(block);
		if (this.blockIndex == -1) {
			throw new IllegalArgumentException("block is not a child of grid");
		}
	}

	public boolean isAtGoal(Grid grid) {
		Block block = grid.getBlocks().get(blockIndex);
		return block.getLeft() == blockPosX &&
			block.getTop() == blockPosY;
	}

	public boolean mayBeAliased(Grid grid, Block block) {
		if (grid.getBlocks().indexOf(block) == blockIndex) {
			return false; 
		}
		return true;
	}

	public int distanceFromGoal(Grid grid) {
		Block block = grid.getBlocks().get(blockIndex);
		int distX = Math.abs(block.getLeft() - blockPosX);
		int distY = Math.abs(block.getTop() - blockPosY);
		return distX + distY;
	}


}
