package com.analogbit.puzzletools.client.slidingblocks.state;

import java.util.ArrayList;

public class MultiGoalState extends ArrayList<GoalState> implements GoalState {
	private static final long serialVersionUID = 1L;
	
	public MultiGoalState() {
	}

	public int distanceFromGoal(Grid grid) {
		int dist = 0;
		int numGoals = this.size();
		for (int i=0; i<numGoals; i++) {
			dist += this.get(i).distanceFromGoal(grid);
		}
		return dist;
	}
	

	public boolean mayBeAliased(Grid grid, Block block) {
		int numGoals = this.size();
		for (int i=0; i<numGoals; i++) {
			GoalState goal = this.get(i);
			if (!goal.mayBeAliased(grid, block)) {
				return false;
			}
		}
		return true;
	}

	/*public boolean isAtGoal(Grid grid) {
		for (GoalState goal : this) {
			if (!goal.isAtGoal(grid)) {
				return false;
			}
		}
		return true;
	}*/


}
