package com.analogbit.puzzletools.client.util;

import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HorizontalPanel;

/**
 * Panel with an ok and cancel button with listener support. 
 */
public class OkCancelPanel extends HorizontalPanel {
	private Button ok = new Button("Ok");
	private Button cancel = new Button("Cancel");
	public OkCancelPanel() {
		this.add(ok);
		this.add(cancel);
		
		ok.addStyleName("okButton");
		cancel.addStyleName("cancelButton");
	}
	
	public void addOkButtonHandler(ClickHandler handler) {
		ok.addClickHandler(handler);
	}
	
	public void addCancelButtonHandler(ClickHandler handler) {
		cancel.addClickHandler(handler);
	}
	
	public Button getOkButton() {
		return ok;
	}
	
	public Button getCancelButton() {
		return cancel;
	}
	
}
