package com.analogbit.puzzletools.client.util;

import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;

/**
 * Panel with a previous and next button.
 */
public class PreviousNextPanel extends HorizontalPanel {
	private Button previousButton = new Button("<< Previous");
	private Button nextButton = new Button("Next >>");
	public static enum DISPLAY_MODE {
		NORMAL,
		HIDDEN,
		DISABLED
	};
	
	public PreviousNextPanel() {
		this.add(previousButton);
		this.add(nextButton);
		this.addStyleName("prevNextPanel");
		
		this.setCellHorizontalAlignment(previousButton, HasHorizontalAlignment.ALIGN_LEFT);
		this.setCellHorizontalAlignment(nextButton, HasHorizontalAlignment.ALIGN_RIGHT);
	}
	
	public PreviousNextPanel(DISPLAY_MODE previousDisplayMode, DISPLAY_MODE nextDisplayMode) {
		this();
		setPreviousDisplayMode(previousDisplayMode);
		setNextDisplayMode(nextDisplayMode);
	}
	
	private static void setDisplayMode(Button button, DISPLAY_MODE mode) {
		switch (mode) {
		case NORMAL:
			button.setVisible(true);
			button.setEnabled(true);
			break;
		case HIDDEN:
			button.setVisible(false);
			break;
		case DISABLED:
			button.setVisible(true);
			button.setEnabled(false);
			break;
		}
	}
	
	public void setNextDisplayMode(DISPLAY_MODE nextDisplayMode) {
		setDisplayMode(nextButton, nextDisplayMode);
	}

	public void setPreviousDisplayMode(DISPLAY_MODE previousDisplayMode) {
		setDisplayMode(previousButton, previousDisplayMode);
	}

	public void addPreviousClickHandler(ClickHandler handler) {
		previousButton.addClickHandler(handler);
	}
	
	
	public void addNextClickHandler(ClickHandler handler) {
		nextButton.addClickHandler(handler);
	}
	
}
